{$APPTYPE CONSOLE}
{$Q+,R+}

program student_checker;
uses
  SysUtils;
const
  maxN = 1000;
  maxD = 1000;
  maxR = 1000;
  maxL = 1000;
var
  d, l, r: array[1..maxN] of integer;
  ko, ka, so, sa: array[1..maxN] of integer;
  vko: array[1..maxN] of integer;
  N: integer;
  Ro, Ra, Mo, Ma: integer;
  sum: integer;
  i: integer;
  fin, fout, fans: text;

  procedure Ex(const ExitResult: string; ExitCode: integer);
  begin
    write(ExitResult);
    try
      close(fin); close(fout);
    except
    end;
    halt(ExitCode);
  end;

begin
  if (ParamCount < 3) then
    Ex('Incorrect call: checker <input> <output> <answer>', 3);
  try
    assign(fin, ParamStr(1)); reset(fin);
  except on e: Exception do
    Ex('Error opening input: ' + e.Message, 3);
  end;
  if SeekEof(fin) then
    Ex('The input file is empty', 3);
  read(fin, n);
  if not((n >= 1) and (n <= maxN)) then
    Ex('Bad value N: not in range 1..maxN', 3);
  for i := 1 to n do
  begin
    read(fin, l[i], d[i], r[i]);
    if not ((d[i] >= 1) and (d[i] <= maxD)) then
      Ex('Bad value d['+IntToStr(i)+']: not in range 1..maxD', 3);
    if not ((r[i] >= 1) and (r[i] <= maxR)) then
      Ex('Bad value r['+IntToStr(i)+']: not in range 1..maxR', 3);
    if not ((l[i] >= 1) and (l[i] <= maxL)) then
      Ex('Bad value l['+IntToStr(i)+']: not in range 1..maxL', 3);
  end;
  if not SeekEof(fin) then
    Ex('Extra input data', 3);
  close(fin);

  try
    assign(fout, ParamStr(2)); reset(fout);
  except on e: Exception do
    Ex('Can''t open output: ' + e.Message, 2);
  end;
  if SeekEof(fout) then
    Ex('Empty output file', 2);
  try
    read(fout, ro);
  except
    Ex('The first line in the output is bad', 2);
  end;
  mo := 0;
  while not SeekEof(fout) do
  begin
    inc(mo);
    try
      read(fout, ko[mo]);
    except
      Ex('Bad task ' + IntToStr(mo), 2);
    end;
    if SeekEof(fout) then
      Ex('Only 1 number: task ' + IntToStr(mo), 2);
    try
      read(fout, so[mo]);
    except
      Ex('Bad task ' + IntToStr(mo), 2);
    end;
  end;
  close(fout);

  try
    assign(fans, ParamStr(3)); reset(fans);
  except on e: Exception do
    Ex('Can''t open answer: ' + e.Message, 3);
  end;
  if SeekEof(fans) then
    Ex('Empty answer file', 3);
  try
    read(fans, ra);
  except
    Ex('The first line in the answer is bad', 3);
  end;
  ma := 0;
  while not SeekEof(fans) do
  begin
    inc(ma);
    try
      read(fans, ka[ma]);
    except
      Ex('Ans: Bad task ' + IntToStr(ma), 3);
    end;
    if SeekEof(fans) then
      Ex('Ans: Only 1 number: task ' + IntToStr(ma), 3);
    try
      read(fans, sa[ma]);
    except
      Ex('Ans: Bad task ' + IntToStr(ma), 3);
    end;
  end;
  close(fans);

  { k[i]   }
  for i := 1 to mo do
  begin
    if not ((ko[i] >= 1) and (ko[i] <= n)) then
      Ex('Incorrect task number k['+IntToStr(i)+']', 1);
  end;

  { k[i]  }
  FillChar(vko, SizeOf(vko), 0);
  for i := 1 to mo do
  begin
    if (vko[ko[i]] <> 0) then
      Ex('Numbers aren''t different: k['+IntToStr(i)+'] is repeated: tasks '+IntToStr(vko[ko[i]])+' and '+IntToStr(i), 1);
    vko[ko[i]] := i;
  end;

  { s[i] }
  for i := 2 to mo do
  begin
    if (so[i] <= so[i-1]) then
      Ex('s[i] doen''t increase: s['+IntToStr(i)+'] <= s['+IntToStr(i-1)+']', 1);
  end;

  {    }
  for i := 2 to mo do
  begin
    if (so[i] <= so[i-1]+l[ko[i-1]]-1) then
      Ex('Incorrect s['+IntToStr(i)+']: working at the previous task wasn''t finished', 1);
  end;

  {   }
  for i := 1 to mo do
  begin
    if (so[i] < 1) then
      Ex('s['+IntToStr(i)+'] < 1', 1);
    if (so[i]+l[ko[i]]-1 > d[ko[i]]) then
      Ex('Incorrect s['+IntToStr(i)+']: the task wasn''t given in time', 1);
  end;

  {      }
  sum := 0;
  for i := 1 to mo do
    sum := sum + r[ko[i]];
  if (sum <> Ro) then
    Ex('The sum of balls doesn''t equal to the number in the first line', 1);

  { }
  if (Ro < Ra) then
    Ex('WA: not optimal', 1);
  if (Ro > Ra) then
    Ex('Etalon solution is incorrect: the solution is better than jury''s', 3);
    
  Ex('OK', 0);
end.